#include <iostream>
#include <iomanip>

using namespace std;

int little_endian()
{
int x=1;
return *(reinterpret_cast<unsigned char *>(&x));
}

unsigned int replace_byte1(unsigned int x, int i, unsigned char b)
{
unsigned int y=x;
reinterpret_cast<unsigned char *>(&y)[i]=b;
return y;
}

unsigned int replace_byte2(unsigned int x, int i, unsigned char b)
{
return (x & ~(0xFF << (i << 3))) | (b << (i << 3));
}

int main()
{
cout << little_endian() << endl;
 
unsigned int tval=0x12345678;
 
cout << "replace_byte1(0x12345678,2,0xAB) = " << setbase(16) << replace_byte1(tval,2,0xAB) << endl;
cout << "replace_byte2(0x12345678,2,0xAB) = " << replace_byte2(tval,2,0xAB) << endl;
cout << "replace_byte1(0x12345678,0,0xAB) = " << replace_byte1(tval,0,0xAB) << endl;
cout << "replace_byte2(0x12345678,0,0xAB) = " << replace_byte1(tval,0,0xAB) << endl;
}
